#pragma once

#include "CoreMinimal.h"
#include "KillerAnimInstance.h"
#include "UObject/NoExportTypes.h"
#include "K41AnimInstance.generated.h"

class UBoolValueStrategy;

UCLASS(Blueprintable, NonTransient)
class UK41AnimInstance : public UKillerAnimInstance
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool IsFastTravellingInHeadMode;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool IsTransitioningFromFullBodyToHead;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool IsTransitioningFromHeadToFullBody;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool IsInHeadMode;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool IsInFullBodyMode;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _isAttackGutsAttack;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _isPerformingMeshHeightTransition;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _meshOffsetShouldBeActive;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _isInteracting;

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	FName _lookAtSubGraphTagName;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FRotator _defaultMeshRotation;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _afterHitRotationSpeedMultiplier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _meshOffsetValue;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _meshHeightChangeSpeedMultiplier;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced, meta=(AllowPrivateAccess=true))
	UBoolValueStrategy* _heightOffsetActivationValue;

public:
	UK41AnimInstance();
};

FORCEINLINE uint32 GetTypeHash(const UK41AnimInstance) { return 0; }
